%define major   11
%define libname %mklibname %{name} %{major}
%define devname %mklibname %{name} -d

# Cyclic dependencies between HLSL and glslang, we can't build with --no-undefined
# for the time being: https://github.com/KhronosGroup/glslang/issues/1484
%define _disable_ld_no_undefined 1

Name:           glslang
# Check tag matching Vulkan sdk-* tag used for other Vulkan components.
Version:        11.12.0
Release:        %mkrel 2
Summary:        Khronos reference front-end for GLSL and ESSL, and sample SPIR-V generator
Group:          System/Libraries
License:        BSD and GPLv3+ and ASL 2.0
URL:            https://github.com/KhronosGroup/glslang
Source0:        https://github.com/KhronosGroup/glslang/archive/%{version}/%{name}-%{version}.tar.xz
Patch1:         0001-CMake-Allow-linking-against-system-installed-SPIRV-T.patch
Patch2:         0001-CMake-Make-glslang-default-resource-limits-STATIC.patch
Patch3:         0002-CMake-Use-VERSION-SOVERSION-for-all-shared-libs.patch

BuildRequires:  cmake
BuildRequires:  pkgconfig(SPIRV-Tools)
BuildRequires:  python3

%description
%{name} is the official reference compiler front end for the OpenGL
ES and OpenGL shading languages. It implements a strict
interpretation of the specifications for these languages.

%package -n %{libname}
Summary:        Library files for glslang
Group:          System/Libraries

%description -n %{libname}
Library files for glslang.

%package -n %{devname}
Summary:        Development files for glslang
Group:              Development/Libraries
Requires:       %{libname} = %{version}-%{release}
Provides:       %{name}-devel = %{version}-%{release}

%description -n %{devname}
%{name} is the official reference compiler front end for the OpenGL
ES and OpenGL shading languages. It implements a strict
interpretation of the specifications for these languages.

%prep
%autosetup -p1

%build
%cmake
%cmake_build

%install
%cmake_install

# Not needed, linked into the shared libs
rm -f %{buildroot}%{_libdir}/*.a

%files
%{_bindir}/glslangValidator
%{_bindir}/spirv-remap

%files -n %{libname}
%{_libdir}/lib%{name}*.so.%{major}
%{_libdir}/lib%{name}*.so.%{version}
%{_libdir}/libHLSL.so.%{major}
%{_libdir}/libHLSL.so.%{version}
%{_libdir}/libSPIRV.so.%{major}
%{_libdir}/libSPIRV.so.%{version}
%{_libdir}/libSPVRemapper.so.%{major}
%{_libdir}/libSPVRemapper.so.%{version}

%files -n %{devname}
%{_includedir}/%{name}/
%{_libdir}/cmake/%{name}/
%{_libdir}/cmake/*.cmake
%{_libdir}/lib%{name}*.so
%{_libdir}/libHLSL.so
%{_libdir}/libSPIRV.so
%{_libdir}/libSPVRemapper.so


%changelog
* Tue Oct 10 2023 tex - 11.12.0-2pclos2023
- rebuild against updates

* Tue Oct 10 2023 tex - 11.12.0-1pclos2023
- new version
